players = {}

pSel = 1

walkSpeed = 175
flySpeed = 300
walkAcc = 150

friction = 1000
gravity = 500
jumpVel = 300
terminalVel = 500

gravFlip = false

function player_update(dt)
	player = players[pSel]

	if(love.keyboard.isDown("a")) 
		then

		if player.grounded then
			player.xvel = -walkSpeed
		else
			player.xvel = player.xvel - walkAcc * dt 
		end

		if(player.xvel < -walkSpeed and player.grounded == true)
			then 
			player.xvel = -walkSpeed 
		end
		
		if player.xvel < -flySpeed and player.grounded == false then
			player.xvel = -flySpeed
		end

		if(player.xdir == 1) 
			then
			if(player.grounded == true) 
				then 
				player.xvel = -player.xvel/4 
			end
			player.xdir = -1
		end

		if player.xvel > 0 and player.grounded == true then
			player.xvel = player.xvel - (friction + walkAcc) * dt
		end

	elseif(love.keyboard.isDown("d")) then
		if player.grounded then
			player.xvel = walkSpeed
		else
			player.xvel = player.xvel + walkAcc * dt 
		end
		
		if(player.xvel > walkSpeed and player.grounded == true) 
			then 
			player.xvel = walkSpeed
		end

		if player.xvel > flySpeed and player.grounded == false then
			player.xvel = flySpeed
		end
		
		if(player.xdir == -1) 
			then
			if(player.grounded == true) 
				then 
				player.xvel = -player.xvel/4 
			end
			player.xdir = 1
		end

		if player.xvel < 0 and player.grounded == true then
			player.xvel = player.xvel + (friction + walkAcc) * dt
		end
	else
		if player.grounded then
			player.xvel = 0
		end 
	end
	
	if(player.grounded == false) then
		if player.flipped == false then
			player.yvel = player.yvel + gravity * dt

			if(player.yvel > terminalVel) then 
				player.yvel = terminalVel 
			end
		else
			player.yvel = player.yvel - gravity * dt

			if(player.yvel < -terminalVel) then 
				player.yvel = -terminalVel 
			end
		end
	end
	if(player.grounded == true) then
		if(love.keyboard.isDown(" ")) then
			if player.flipped == false then
				player.yvel = -jumpVel
			else
				player.yvel = jumpVel
			end

			player.grounded = false
		end
	end
	
	player.x,player.y,player.xvel,player.yvel,player.grounded = block_col(player.x,player.y,player.xvel,player.yvel,player.w,player.h,player.grounded, player.flipped,dt)
	player.x,player.y,player.xvel,player.yvel,player.grounded = player_col(player.x,player.y,player.xvel,player.yvel,player.w,player.h,player.grounded,dt)
	player.y = player.y + player.yvel * dt
	player.x = player.x + player.xvel * dt

	for i,v in ipairs(players) do
		for k,b in ipairs(hazards) do
			if CheckCollision(v.x - v.w/2, v.y - v.h/2, v.w, v.h, b.x, b.y, b.w, b.h) == true then
				restart()
			end
		end
	end

	if love.keyboard.isDown("w") then
		player.tp = true
	else
		player.tp = false
	end

	player.tpCool = player.tpCool - 1
end

function player_col(x,y,dx,dy,w,h,grounded,dt)
	local onground = grounded
	for i,v in ipairs(players) do
		if(i ~= pSel) then
			if player.flipped == false then
				if(dy > 0) then
					if(x + w/2 >= v.x - v.w/2 and x - w/2 <= v.x + v.w/2) then
						if(y + h/2 <= v.y - v.h/2 and y + h/2 + dy * dt >= v.y - v.h/2) then
							dy = 0
							y = v.y - h
							onground = true
						end
					end
				end
			else
				if(dy < 0) then
					if(x + w/2 >= v.x - v.w/2 and x - w/2 <= v.x + v.w/2) then
						if(y - h/2 >= v.y + v.h/2 and y - h/2 + dy * dt <= v.y + v.h/2) then
							dy = 0
							y = v.y + h
							onground = true
						end
					end
				end
			end	
		end
	end	

	return x,y,dx,dy,onground
end

function player_keypress(key)
	if state == "playing" then
		if(key == "q") then
			local last = players[pSel]

			if nextP.xvel > 10 or nextP.yvel > 10 then
				swapTimer = 90
			end

			pSel = pSel + 1
			if(pSel > #players) then
				pSel = 1
			end
		elseif(key == "r") then
			restart()
		elseif(key == "f") and gravFlip == true then
			player.flipped = not player.flipped
			player.onground = false
		elseif (key == "tab") then
			TIMEMOD = 20
		end
	end
end

function player_draw()
	for i,v in ipairs(players) do
		love.graphics.setColor(players[i].colour)
		love.graphics.rectangle("fill",v.x - v.w/2,v.y - v.h/2,v.w,v.h)
	end

	nextSel = pSel + 1; if(nextSel > #players) then nextSel = 1 end
	player = players[pSel]
	nextP = players[nextSel]

	if (player.xvel >= walkSpeed) or (player.xvel <= -walkSpeed) then
		love.graphics.setColor(130,105,83,150)
	else
		love.graphics.setColor(255,255,255,150)	
	end

	if player.flipped == false then
		love.graphics.circle("fill",player.x, player.y - 10,5,30)	
	else
		love.graphics.circle("fill",player.x, player.y + (player.h/2) - 10,5,30)
	end

	if (nextP.xvel >= walkSpeed) or (nextP.xvel <= -walkSpeed) 
		then
		love.graphics.setColor(103,105,83,150)
	else
		love.graphics.setColor(255,255,255,150)	
	end

	if nextP.flipped == false then
		love.graphics.circle("line",nextP.x,nextP.y - 10,5,30)
	else
		love.graphics.circle("line",nextP.x, nextP.y + (nextP.h/2) - 10,5,30)
	end

	love.graphics.setColor(255,255,255,255)
end

function add_player(x,y,w,h, r,g,b, id)
	local pl = {}
	pl.x = x
	pl.y = y
	pl.w = w
	pl.h = h
	pl.xvel = 0
	pl.yvel = 0
	pl.grounded = false
	pl.freeze = false
	pl.colour = {r,g,b}
	pl.id = id
	pl.tp = false
	pl.tpCool = 0
	pl.flipped = false

	table.insert(players,pl)
end