blocks = {}
hazards = {}
zones = {}
text = {}
tpZones = {}

currentLevel = 1
zonesFilled = 0
winTimer = 180

gridS = 25

currentLevelX, currentLevelY = 10,10

mapX = 0
mapY = 0

showConnections = false

function world_update(dt)
	for i,v in ipairs(players) do
		for k,b in ipairs(zones) do
			if v.id == b.id
				then
				if CheckCollision(v.x - v.w/2, v.y - v.h/2, v.w, v.h, b.x, b.y, b.w, b.h) == true
					then
					b.playerIn = true
				else
					b.playerIn = false
				end

				zones[k].colour = {zones[k].colour[1],zones[k].colour[2],zones[k].colour[3], ((winTimer + 1) / 300) * 100}
			end

			if b.playerIn == true and b.checked == false
				then
				zonesFilled = zonesFilled + 1
				b.checked = true
			elseif b.playerIn == false and b.checked == true
				then
				zonesFilled = zonesFilled -1
				b.checked = false
			end

			if winTimer < 0 then
				nextLevel()
			end

			if zonesFilled == #zones
				then
				winTimer = winTimer - 1 * (dt * 300)
			else
				winTimer = 300
			end

			if zonesFilled > #zones
				then
				zonesFilled = 0
			end
		end

		for k,b in ipairs(tpZones) do
			if CheckCollision(player.x - player.w/2, player.y - player.h/2, player.w, player.h, b.x, b.y, b.w, b.h) == true
				then
				b.playerIn = true
			else
				b.playerIn = false
			end
		end
	end

	for i,v in ipairs(tpZones) do
		if v.playerIn == true and player.tp == true and player.tpCool <= 0
			then
			local xDisplace = math.abs(v.x - player.x)
			local yDisplace = math.abs(v.y - player.y)

			for k,b in ipairs(tpZones) do --FIND DEST ZONE
				if v.linkedTo == b.id then
					player.x = b.x + xDisplace
					player.y = b.y + yDisplace
					player.tpCool = 20
				end
			end
		end
	end

	if(love.keyboard.isDown("e")) then
		showConnections = true
	else
		showConnections = false
	end
end

function world_draw()
	love.graphics.setColor(0,0,0)
	for i,v in ipairs(blocks) do
		love.graphics.rectangle("fill",v.x,v.y,v.w,v.h)
	end

	love.graphics.setColor(159,29,53)
	for k,b in ipairs(hazards) do
		love.graphics.rectangle("fill",b.x,b.y,b.w,b.h)
	end

	love.graphics.setColor(255, 255, 255)
	for o,n in ipairs(zones) do
		love.graphics.setColor(zones[o].colour)
		love.graphics.rectangle("fill",n.x,n.y,n.w,n.h)
		love.graphics.setColor(zones[o].colour, 255)
	end

	love.graphics.setShader(bloom2)
	for o,n in ipairs(tpZones) do
		love.graphics.setColor(tpZones[o].colour)
		love.graphics.rectangle("fill",n.x,n.y,n.w,n.h)
		love.graphics.setColor(tpZones[o].colour, 255)

		if showConnections == true then
			for i,v in ipairs(tpZones) do
				if n.id == v.linkedTo then 
					love.graphics.line(v.x + v.w/2, v.y + v.h/2, n.x + n.w/2, n.y + n.h/2)
				end
			end
		end
	end
	love.graphics.setShader(BnW)

	love.graphics.setColor(255,255,255)
	for l,m in ipairs(text) do
		love.graphics.print(m.txt, m.x,m.y, m.r, m.sx,m.sy)
	end

	love.graphics.setFont(levelText)
	love.graphics.print("Current Level: "..currentLevel, currentLevelX,currentLevelY)
	love.graphics.setFont(pixelTextS)
end

function add_block(x,y,w,h)
	local bl = {}
	bl.x = x
	bl.y = y
	bl.w = w
	bl.h = h

	table.insert(blocks,bl)
end

function add_hazard(x,y,w,h)
	local hz = {}
	hz.x = x
	hz.y = y
	hz.w = w
	hz.h = h

	table.insert(hazards,hz)
end

function add_zone(x,y,w,h, r,g,b,a, id)
	local zn = {}
	zn.x = x
	zn.y = y
	zn.w = w
	zn.h = h
	zn.colour = {r,g,b,a}
	zn.id = id
	zn.playerIn = false
	zn.checked = false
	zn.timer = 180

	table.insert(zones,zn)
end

function add_tp(x,y,w,h, id,dest)
	local tp = {}
	tp.x = x
	tp.y = y
	tp.w = w
	tp.h = h
	tp.colour = {207,207,196,100}
	tp.linkedTo = dest
	tp.id = id
	tp.playerIn = false

	table.insert(tpZones,tp)
end

function add_text(txt, x,y, r, sx,sy)
	local tx = {}
	tx.txt = txt
	tx.x = x
	tx.y = y
	tx.r = r
	tx.sx = sx
	tx.sy = sy
	table.insert(text, tx)
end

function block_col(x,y,dx,dy,w,h,grounded, flipped,dt)
	local onland = false
	for i,v in ipairs(blocks) do
		if flipped == false then 
			if(x + w/2 > v.x and x - w/2 < v.x + v.w) then
				if(y - h/2 > v.y + v.h and y - h/2 + dy * dt < v.y + v.h) then
					y = v.y + v.h + h/2
					dy = 0
				end
				if(y + h/2 < v.y and y + h/2 + dy * dt > v.y) then
					y = v.y - h/2
					dy = 0
					grounded = true
				end
			end
		else
			if(x + w/2 > v.x and x - w/2 < v.x + v.w) then
				if(y - h/2 < v.y and y - h/2 - dy * dt > v.y) then
					y = v.y - h/2
					dy = 0
				end
				if(y - h/2 > v.y + v.h and y - h/2 + dy * dt < v.y + v.h) then
					y = v.y + v.h + h/2
					dy = 0
					grounded = true
				end
			end
		end
			
		if(y + h/2 > v.y and y - h/2 < v.y + v.h) then
			if(x + w/2 < v.x and x + w/2 + dx * dt > v.x or (dx > 1 and x + w/2 == v.x)) then
				x = v.x - w/2
				dx = 0
			end
			if(x - w/2 > v.x + v.w and x - w/2 + dx * dt < v.x + v.w or (x - w/2 == v.x + v.w and dx < 0)) then
				x = v.x + v.w + w/2
				dx = 0
			end
		end
		
		if flipped == false then
			if(grounded == true and y + h/2 == v.y and x + w/2 > v.x and x - w/2 < v.x + v.w) then
				onland = true
			end
		else
			if(grounded == true and y - h/2 == v.y + v.h and x + w/2 > v.x and x - w/2 < v.x + v.w) then
				onland = true
			end
		end			
	end
	if(onland == true) then
		grounded = true
	else
		grounded = false
	end
	
	return x,y,dx,dy,grounded
end
 
function restart()
	players = {}
	blocks = {}
	hazards = {}
	zones = {}
	text = {}
	tpZones = {}
	zonesFilled = 0

	if currentLevel == 1 then
		LevelOne()
	elseif currentLevel == 2 then 
		LevelTwo()
	elseif currentLevel == 3 then
		LevelThree()
	elseif currentLevel == 4 then
		LevelFour()
	elseif currentLevel == 5 then
		LevelFive()
	elseif currentLevel == 6 then
		LevelSix()
	elseif currentLevel == 7 then 
		LevelSeven()
	elseif currentLevel == 8 then
		LevelEight()
	elseif currentLevel == 9 then
		LevelNine()
	elseif currentLevel == 10 then
		LevelTen()
	elseif currentLevel == 11 then
		Ending()
		state = "end"
	end

	if currentLevel == "TEST" then
		TESTAREA()
	end

	pSel = 1
end

function CheckCollision(x1,y1,w1,h1, x2,y2,w2,h2)
  return x1 < x2+w2 and
         x2 < x1+w1 and
         y1 < y2+h2 and
         y2 < y1+h1 
end

function nextLevel()
	currentLevel = currentLevel + 1
	restart()
end
